%% TD3 - Localisation et Navigation de Robots
%%
%% Exercice 2: Utilisation du filtre de Kalman etendu (EKF) pour la localisation et cartographie
%% b) Localisation basee carte

clear
close all
clc 

% Creer un vehicule "veh" avec une matrice de covariance odometrique S
S = diag([0.1, 1*pi/180].^2);
veh = Vehicle(S);
 
% Ajouter un pilote avec une trajectoire aleatoire
veh.add_driver(RandomPath(20, 2));
 
% Creer une carte avec 20 marqueurs
map = Map(20);
 
% Creer un capteur qui utilise la carte et l'etat du vehicule  
% pour estimer les primitives du capteur avec une covariance W 
W = diag([0.005, 0.5*pi/180].^2);
sensor = RangeBearingSensor(veh, map, W, 'animate');

% Definir le filtre de Kalman avec les covariances estimees Vest et 
% West et la covariance de l'etat initial du vehicule P0, puis executer 
% le filtre pour N pas de temps.
Vest = 0.99*S;
West = 0.99*W;
P0 = 1e-3*eye(3);
ekf = EKF(veh, Vest, P0, sensor, West, []);
N = 1000;
ekf.run(N);
 
% Tracer la carte, afficher le chemin du vehicule, superposer 
% le chemin estime, et ajouter des ellipses d'incertitude 
% tous les 10 pas de temps
map.plot();
veh.plot_xy('b');
ekf.plot_xy('r');
ekf.plot_ellipse(10,'k')
xlabel('x [m]')
ylabel('y [m]')
title('Ex. 2b: Localisation basée carte - chemin estimé (rouge); chemin vrai (bleu)')

% Affichage de l'evolution temporelle de l'erreur d'estimation sur x, y et theta 
% et des bandes 3 sigma (en rose) 
figure(2)
ekf.plot_error()