%% TD3 - Localisation et Navigation de Robots
%%
%% Exercice 2: Utilisation du filtre de Kalman etendu (EKF) pour la localisation et cartographie
%% c) Creation de cartes par un robot 

clear 
close all
clc 

% Creer un vehicule "veh" avec une matrice de covariance odometrique S
S = diag([0.1, 1*pi/180].^2);
veh = Vehicle(S);
 
% Ajouter un pilote avec une trajectoire aleatoire
veh.add_driver(RandomPath(20, 2));

% Creer un capteur qui utilise la carte et l'etat du vehicule 
% pour estimer les primitives du capteur avec une covariance W 
map = Map(20);
W = diag([0.005, 0.5*pi/180].^2);
sensor = RangeBearingSensor(veh, map, W, 'animate');
 
% Definir le filtre de Kalman avec la covariance estimee West 
% et un vehicule "parfait" (pas de covariance, []) puis executer 
% le filtre pour N pas de temps.
West = 0.9*W;
ekf = EKF(veh, [], [], sensor, West, []);
N = 1000;
ekf.run(N);
 
% Tracer la carte et superposer les ellipses d'incertitude 3 sigma estimees 
map.plot();
ekf.plot_map(3, 'k')
xlabel('x [m]')
ylabel('y [m]')
title({'Ex. 2c: Création de cartes par un robot avec l''EKF:','balise estimée (croix); balise vraie (losange)'})